#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <time.h>
#include <windows.h>
#include "K8055D.h"

double timetic=(double)(CLOCKS_PER_SEC);

char cfg_name[21]="tgb2cfg.txt";


double harm_delay(long delay0) {

   long j;
   double sum;


      sum=0.0;

      for (j=1; j<=delay0; j++) {
         sum=sum+1.0/(double)(j);
      } /* for j */

      return(sum);

} /* harm_delay */


int main() {

	/* Variable Declarations */

	int Row, Col;
	int BoardNum = 0;
	int ULStat = 0;
	int PortNum, Direction;
	long DataValue;
	int BitLevel;
	int BitNum;
	long BitValue;
	int hilo;
	char s[32];  // string for user input

	long j, n, d0, d1, x1, y1, flag1, cardadr;

	double sum0;

	char cc;

	double pi1 = 3.14159265358979323;




	/* specify the port number */

	cardadr = 0;
	OpenDevice(cardadr);


	/* get a user value to write to the port */

	DataValue = 8;


	/* write BitValue to BitNum of FIRSTPORTA

		Parameters:
			BoardNum    :the number used by CB.CFG to describe this board
			PortNum     :must be FIRSTPORTA
			BitNum      :the number of the bit to be set to BitValue
			BitValue    :the value written to the port   */

	for (j = 1; j <= 8; j++) {

	   BitNum = j;
	   BitValue = 1;

	   SetDigitalChannel(BitNum);

    } /* for j */

	BitNum = 3;
	BitValue = 1;

	ClearDigitalChannel(BitNum);

    BitNum = 6;
	BitValue = 1;

	ClearDigitalChannel(BitNum);


	printf("\nUse the keys a z and , . to run the stepper motors 100 steps at the time.\n\n");
	printf("Quit program by pressing p.\n\n");

	d0 = 10000;
	d1 = 10;

	n = 100;

	x1 = 0;
	y1 = 0;

	sum0 = 0.0;

	printf("%8ld %8ld\n\n", y1, x1);

	cc = '1';
	flag1 = 0;

	while (flag1 == 0) {

		if (kbhit()) {
			cc = getch();
		} /* if */

		if (cc == 'a') {

			BitNum = 2;
			BitValue = 1;

			ClearDigitalChannel(BitNum);

			for (j = 1; j <= n; j++) {

				BitNum = 1;
				BitValue = 1;

				ClearDigitalChannel(BitNum);

                                Sleep(0);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				BitNum = 1;
				BitValue = 0;

				SetDigitalChannel(BitNum);

			        Sleep(0);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				y1--;

			} /* for j */

			printf("%8ld %8ld\n",x1, y1);

		} /* if */
		
		if (cc == 'z') {

			BitNum = 2;
			BitValue = 0;

			SetDigitalChannel(BitNum);

			for (j = 1; j <= n; j++) {

				BitNum = 1;
				BitValue = 1;

				ClearDigitalChannel(BitNum);

				Sleep(0);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				BitNum = 1;
				BitValue = 0;

				SetDigitalChannel(BitNum);
			

			    Sleep(0);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				y1++;

			} /* for j */

			printf("%8ld %8ld\n", x1, y1);


		} /* if */


		if (cc == '.') {

			BitNum = 5;
			BitValue = 1;

			ClearDigitalChannel(BitNum);

			for (j = 1; j <= n; j++) {


				BitNum = 4;
				BitValue = 1;

				ClearDigitalChannel(BitNum);

                                Sleep(0);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				BitNum = 4;
				BitValue = 0;

				SetDigitalChannel(BitNum);

                                Sleep(0);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				x1--;

			} /* for j */

			printf("%8ld %8ld\n", x1, y1);

		} /* if */
		
		if (cc == ',') {

			BitNum = 5;
			BitValue = 0;

			SetDigitalChannel(BitNum);

			for (j = 1; j <= n; j++) {

				BitNum = 4;
				BitValue = 1;

				ClearDigitalChannel(BitNum);

				Sleep(0);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				BitNum = 4;
				BitValue = 0;

				SetDigitalChannel(BitNum);

                                Sleep(0);

				/*
				sum0 = sum0 + harm_delay(d1 * d0);
				*/

				x1++;

			} /* for j */

			printf("%8ld %8ld\n", x1, y1);

        } /* if */

		if (cc == 'p') {
			flag1 = 1;
		} /* if */

		cc = '1';

    } /* while */


	BitNum = 3;
	BitValue = 0;

	SetDigitalChannel(BitNum);

    BitNum = 6;
	BitValue = 0;

	SetDigitalChannel(BitNum);

    for (j = 1; j <= 8; j++) {

		BitNum = j;
		BitValue = 0;

		SetDigitalChannel(BitNum);

    } /* for j */


    printf("\n%12.5lf\n",sum0);


    } /* End program */



